﻿using System;
using System.Text;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 이벤트를 설정한다.

            this.calculateButton.Click += calculateButton_Click;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 계산하기 버튼 클릭시 처리하기 - calculateButton_Click(sender, e)

        /// <summary>
        /// 계산하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void calculateButton_Click(object sender, EventArgs e)
        {
            long maximumPrimeNumber = long.Parse(this.maximumPrimeNumberTextBox.Text);

            StringBuilder stringBuilder = new StringBuilder();

            PrimeNumberGenerator generator = new PrimeNumberGenerator();

            foreach(long primeNumber in generator)
            {
                if(primeNumber > maximumPrimeNumber)
                {
                    break;
                }

                stringBuilder.Append(primeNumber.ToString() + " ");
            }

            string text = stringBuilder.ToString();

            this.primeNumberListTextBox.Text = text.Substring(0, text.Length - 1);
        }

        #endregion
    }
}