﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 소수 생성자
    /// </summary>
    public class PrimeNumberGenerator : IEnumerable<long>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 열거자 구하기 - GetEnumerator()

        /// <summary>
        /// 열거자 구하기
        /// </summary>
        /// <returns>열거자</returns>
        public IEnumerator<long> GetEnumerator()
        {
            yield return 2;

            for(long i = 3; ; i += 2)
            {
                if(IsOddPrime(i))
                {
                    yield return i;
                }
            }
        }

        #endregion
        #region 열거자 구하기 - IEnumerable.GetEnumerator()

        /// <summary>
        /// 열거자 구하기
        /// </summary>
        /// <returns>열거자</returns>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 홀수 소수 여부 구하기 - IsOddPrime(value)

        /// <summary>
        /// 홀수 소수 여부 구하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>홀수 소수 여부</returns>
        private bool IsOddPrime(long value)
        {
            long sqrt = (long)Math.Sqrt(value);

            for(long i = 3; i <= sqrt; i += 2)
            {
                if(value % i == 0)
                {
                    return false;
                }
            }

            return true;
        }

        #endregion
    }
}